var U = Object.defineProperty;
var F = (r, e, t) => e in r ? U(r, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : r[e] = t;
var R = (r, e, t) => (F(r, typeof e != "symbol" ? e + "" : e, t), t);
class u extends Error {
  constructor(t, s) {
    super(t);
    R(this, "code");
    R(this, "stack");
    R(this, "context");
    this.context = s, s instanceof Error && (this.name = s.name, this.stack = s.stack);
  }
}
const x = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], D = "browserstack-client", B = "3.0.0-next.2", E = [D, B].join("/"), L = ["node", process.versions.node].join("/"), z = [E, L].join(" "), $ = {
  name: D,
  version: B,
  userAgent: z
}, O = {
  "Content-Type": "application/json"
};
function T(r) {
  const {
    fetch: e = globalThis.fetch,
    querySerializer: t,
    bodySerializer: s,
    ...a
  } = r ?? {};
  let n = a.baseUrl ?? "";
  n.endsWith("/") && (n = n.slice(0, -1));
  async function m(i, o) {
    const {
      fetch: g = e,
      headers: c,
      body: h,
      params: f = {},
      parseAs: l = "json",
      querySerializer: k = t ?? M,
      bodySerializer: d = s ?? H,
      ...w
    } = o || {}, v = W(i, {
      baseUrl: n,
      params: f,
      querySerializer: k
    }), y = K(
      O,
      r == null ? void 0 : r.headers,
      c,
      f.header
    ), S = {
      redirect: "follow",
      ...a,
      ...w,
      headers: y
    };
    h && (S.body = d(h)), S.body instanceof FormData && y.delete("Content-Type");
    const p = await g(v, S);
    if (p.status === 204 || p.headers.get("Content-Length") === "0")
      return p.ok ? { data: {}, response: p } : { error: {}, response: p };
    if (p.ok) {
      if (l === "stream")
        return { data: p.clone().body, response: p };
      const A = p.clone();
      return {
        data: typeof A[l] == "function" ? await A[l]() : await A.text(),
        response: p
      };
    }
    let I = {};
    try {
      I = await p.clone().json();
    } catch {
      I = await p.clone().text();
    }
    return { error: I, response: p };
  }
  return {
    /** Call a GET endpoint */
    async GET(i, o) {
      return m(i, { ...o, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(i, o) {
      return m(i, { ...o, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(i, o) {
      return m(i, { ...o, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(i, o) {
      return m(i, { ...o, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(i, o) {
      return m(i, { ...o, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(i, o) {
      return m(i, { ...o, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(i, o) {
      return m(i, { ...o, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(i, o) {
      return m(i, { ...o, method: "TRACE" });
    }
  };
}
function M(r) {
  const e = [];
  if (r && typeof r == "object")
    for (const [t, s] of Object.entries(r)) {
      const a = G([t], s);
      a && e.push(a);
    }
  return e.join("&");
}
function G(r, e) {
  if (e != null) {
    if (typeof e == "string")
      return `${_(r)}=${encodeURIComponent(e)}`;
    if (typeof e == "number" || typeof e == "boolean")
      return `${_(r)}=${String(e)}`;
    if (Array.isArray(e)) {
      if (!e.length)
        return;
      const t = [];
      for (const s of e) {
        const a = G(r, s);
        a !== void 0 && t.push(a);
      }
      return t.join("&");
    }
    if (typeof e == "object") {
      if (!Object.keys(e).length)
        return;
      const t = [];
      for (const [s, a] of Object.entries(e))
        if (a != null) {
          const n = G([...r, s], a);
          n !== void 0 && t.push(n);
        }
      return t.join("&");
    }
    return encodeURIComponent(`${_(r)}=${String(e)}`);
  }
}
function _(r) {
  let e = r[0];
  for (const t of r.slice(1))
    e += `[${t}]`;
  return e;
}
function H(r) {
  return JSON.stringify(r);
}
function W(r, e) {
  let t = `${e.baseUrl}${r}`;
  if (e.params.path)
    for (const [a, n] of Object.entries(e.params.path))
      t = t.replace(`{${a}}`, encodeURIComponent(String(n)));
  const s = e.querySerializer(e.params.query ?? {});
  return s && (t += `?${s}`), t;
}
function K(...r) {
  const e = new Headers();
  for (const t of r) {
    if (!t || typeof t != "object")
      continue;
    const s = t instanceof Headers ? t.entries() : Object.entries(t);
    for (const [a, n] of s)
      n === null ? e.delete(a) : n !== void 0 && e.set(a, n);
  }
  return e;
}
const [{ variables: b }, { variables: j }] = x, N = `${b.scheme.default}://${b.host.default}${b.basePath ? b.basePath.default : ""}`, V = `${j.scheme.default}://${j.host.default}${j.basePath ? j.basePath.default : ""}`;
class q {
  constructor(e) {
    R(this, "sdk");
    R(this, "sdkCloud");
    const t = e.username ?? process.env.BROWSERSTACK_USERNAME;
    if (e.usernameOptional !== !0 && (typeof t != "string" || !t.trim().length))
      throw new u("Missing options.username");
    const s = e.key ?? process.env.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new u("Missing options.key");
    const a = {
      ...e,
      baseUrl: e.baseUrl ?? N,
      headers: {
        ...e.headers,
        Authorization: t ? `Basic ${Buffer.from(`${t}:${s}`).toString("base64")}` : void 0,
        "User-Agent": $.userAgent
      }
    };
    this.sdk = T(a), this.sdkCloud = T({
      ...a,
      baseUrl: V
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(e, ...t) {
    const s = await this.sdk.GET(e, ...t);
    if (s.error || !s.data)
      throw new u("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePostRequest(e, ...t) {
    const s = await this.sdk.POST(e, ...t);
    if (s.error || !s.data)
      throw new u("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(e, ...t) {
    const s = await this.sdkCloud.GET(e, ...t);
    if (s.error || !s.data)
      throw new u("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(e, ...t) {
    const s = await this.sdkCloud.POST(e, ...t);
    if (s.error || !s.data)
      throw new u("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePutRequest(e, ...t) {
    const s = await this.sdk.PUT(e, ...t);
    if (s.error || !s.data)
      throw new u("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(e, ...t) {
    const s = await this.sdk.PATCH(e, ...t);
    if (s.error || !s.data)
      throw new u("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(e, ...t) {
    const s = await this.sdk.DELETE(e, ...t);
    if (s.error || !s.data)
      throw new u("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  getAccountStatus(e) {
    return this.makeGetRequest("/status", e);
  }
}
class J extends q {
  /**
   * Constructs a new instance of the AppAutomateClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Retrieves the plan information for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the plan information.
   */
  getPlan(e) {
    return this.makeGetRequest("/app-automate/plan.json", e);
  }
  /**
   * Retrieves the list of devices available for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the list of devices.
   */
  getDevices(e) {
    return this.makeGetRequest("/app-automate/devices.json", e);
  }
  /**
   * Retrieves the projects from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects.
   */
  getProjects(e) {
    return this.makeGetRequest("/app-automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project in the App Automate API.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project data.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/app-automate/projects/{projectId}.json", {
      ...s,
      params: {
        path: {
          projectId: e
        }
      },
      body: t
    });
  }
  /**
   * Deletes a project.
   * @param projectId The ID of the project to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the App Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/app-automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((a) => a.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the build information, including the build details and associated sessions.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (a) => a.automation_session
      )
    }));
  }
  /**
   * Updates a build in the App Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build information.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the updated build.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/app-automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((a) => {
      if ("error" in a)
        throw new u(a.error, { response: a });
      return a.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param body - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", t.file, t.filename), a;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param body - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", t.file, t.filename), a;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the session details for a given session ID.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates the status of a session in the App Automate API.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session status.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the updated automation session.
   */
  updateSessionStatus(e, t, s) {
    return this.makePutRequest("/app-automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((a) => a.automation_session);
  }
  /**
   * Deletes a session in the App Automate API.
   * @param sessionId - The ID of the session to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the session logs for a specific build and session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the session logs.
   */
  getSessionLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/logs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the device logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the device logs.
   */
  getSessionDeviceLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/devicelogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appiumlogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the network logs for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/networklogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the app profiling data.
   */
  getSessionAppProfilingDataV1(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the API request.
   * @returns A promise that resolves with the app profiling data.
   */
  getSessionAppProfilingDataV2(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling/v2",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Uploads a media file to the App Automate API.
   *
   * @param body - The request body containing the media file to upload.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/app-automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return s.append("file", e.file, e.filename), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the media files associated with the App Automate session.
   *
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of media files, or an empty array if no media files are found.
   */
  getMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_media_files",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Retrieves media files by custom ID.
   * @param customId - The custom ID to filter media files.
   * @param options - Optional fetch options.
   * @returns A promise that resolves to an array of media files or an empty array if no media files are found.
   */
  getMediaFilesByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_media_files/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the group's media files from the App Automate API.
   *
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of group media files, or an empty array if the response contains a "message" property.
   */
  getGroupMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_group_media",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Deletes a media file from the app automate custom media.
   * @param mediaId The ID of the media file to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest(
      "/app-automate/custom_media/delete/{mediaId}",
      {
        ...t,
        params: {
          path: {
            mediaId: e
          }
        }
      }
    );
  }
  /**
   * Uploads an Appium app to BrowserStack App Automate.
   *
   * @param body - The request body containing the app file or URL to be uploaded.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the upload request.
   */
  uploadAppiumApp(e, t) {
    return this.makePostRequest("/app-automate/upload", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the list of Appium apps from the App Automate API.
   *
   * @param options - Optional fetch options for customizing the request.
   * @returns A promise that resolves to an array of Appium apps, or an empty array if no apps are found.
   */
  getAppiumApps(e) {
    return this.makeGetRequest("/app-automate/recent_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Retrieves the Appium apps by custom ID.
   * @param customId The custom ID of the app.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Appium apps.
   */
  getAppiumAppsByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_apps/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the list of App Automate apps for the group using the specified fetch options.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the list of group apps, or an empty array if there is a "message" property in the response data.
   */
  getAppiumGroupApps(e) {
    return this.makeGetRequest("/app-automate/recent_group_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Deletes an Appium app.
   *
   * @param appId - The ID of the app to delete.
   * @param options - Optional fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteAppiumApp(e, t) {
    return this.makeDeleteRequest("/app-automate/app/delete/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads a Flutter app for App Automate.
   *
   * @param body - The request body containing the app file or URL and other optional parameters.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadFlutterApp(e, t, s) {
    return this.makePostRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/app" : "/app-automate/flutter-integration-tests/v2/ios/test-package",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return "file" in t ? a.append("file", t.file, t.filename) : a.append("url", t.url), t.custom_id && a.append("custom_id", t.custom_id), a;
        }
      }
    );
  }
  /**
   * Retrieves the list of Flutter apps for Android.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of Flutter apps, or an empty array if no apps are found.
   */
  getFlutterApps(e, t) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps" : "/app-automate/flutter-integration-tests/v2/ios/test-packages",
      t
    ).then(
      (s) => "apps" in s ? s.apps : "test_packages" in s ? s.test_packages : []
    );
  }
  /**
   * Retrieves the Flutter app with the specified appId.
   * @param appId The ID of the Flutter app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Flutter app.
   */
  getFlutterApp(e, t, s) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    ).then((a) => "app" in a ? a.app : a.test_package);
  }
  /**
   * Deletes a Flutter app from the BrowserStack App Automate service.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteFlutterApp(e, t, s) {
    return this.makeDeleteRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    );
  }
  /**
   * Uploads an Espresso app to BrowserStack.
   *
   * @param body - The request body containing the app file or URL.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response from the server.
   */
  uploadEspressoApp(e, t) {
    return this.makePostRequest("/app-automate/espresso/v2/app", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the Espresso apps from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves to an array of Espresso apps.
   */
  getEspressoApps(e) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the Espresso app with the specified appId.
   * @param appId The ID of the Espresso app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Espresso app.
   */
  getEspressoApp(e, t) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an Espresso app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is deleted.
   */
  deleteEspressoApp(e, t) {
    return this.makeDeleteRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads an XCUITest app to BrowserStack App Automate.
   *
   * @param body - The request body containing the XCUITest app file or URL.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the request.
   */
  uploadXCUITestApp(e, t) {
    return this.makePostRequest("/app-automate/xcuitest/v2/app", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in e ? s.append("file", e.file, e.filename) : s.append("url", e.url), e.custom_id && s.append("custom_id", e.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the XCUITest apps available in the BrowserStack App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of XCUITest apps.
   */
  getXCUITestApps(e) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the XCUITest app with the specified appId.
   * @param appId The ID of the XCUITest app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the XCUITest app.
   */
  getXCUITestApp(e, t) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an XCUITest app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteXCUITestApp(e, t) {
    return this.makeDeleteRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  uploadDetoxAndroidApp(e, t, s) {
    return this.makePostRequest(
      e ? "/app-automate/detox/v2/android/app" : "/app-automate/detox/v2/android/app-client",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return "file" in t ? a.append("file", t.file, t.filename) : a.append("url", t.url), t.custom_id && a.append("custom_id", t.custom_id), a;
        }
      }
    );
  }
}
class X extends q {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(e) {
    return this.makePutRequest("/automate/recycle_key.json", e);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(e) {
    return this.makeGetRequest("/automate/plan.json", e);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/automate/browsers.json", e);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(e) {
    return this.makeGetRequest("/automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((a) => a.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (a) => a.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((a) => {
      if ("error" in a)
        throw new u(a.error, { response: a });
      return a.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(e, t) {
    return this.makeDeleteRequest("/automate/builds", {
      ...t,
      params: {
        query: {
          "buildId[]": e
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(e, t, s) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...s,
      params: {
        path: {
          buildId: e
        },
        query: t
      }
    }).then((a) => a.map((n) => n.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(e, t, s) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((a) => a.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(e, t) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...t,
      params: {
        query: {
          "sessionId[]": e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param body - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", t.file, t.filename), a;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param body - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", t.file, t.filename), a;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(e, t) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...t,
        params: {
          path: {
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param body - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: () => {
        const s = new FormData();
        return s.append("file", e.file, e.filename), s;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(e) {
    return this.makeGetRequest("/automate/recent_media_files", e);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...t,
      params: {
        path: {
          mediaId: e
        }
      }
    });
  }
}
class C extends q {
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(e, t) {
    return this.makeGetRequest("/browsers", {
      ...t,
      params: {
        query: {
          ...e,
          flat: typeof (e == null ? void 0 : e.flat) == "boolean" ? e.flat : !0
        }
      }
    });
  }
  createWorker(e, t) {
    return this.makePostRequest("/worker", {
      ...t,
      body: e
    });
  }
  getWorkers(e) {
    return this.makeGetRequest("/workers", e);
  }
  getWorker(e, t) {
    return this.makeGetRequest("/worker/{workedId}", {
      ...t,
      params: {
        path: {
          workedId: e
        }
      }
    });
  }
  deleteWorker(e, t) {
    return this.makeDeleteRequest("/worker/{workedId}", {
      ...t,
      params: {
        path: {
          workedId: e
        }
      }
    });
  }
}
class Q extends q {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/screenshots/browsers.json", e);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(e, t) {
    return this.makePostRequest("/screenshots", {
      ...t,
      body: e
    });
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(e, t) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...t,
      params: {
        path: {
          jobId: e
        }
      }
    });
  }
}
class Y extends q {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://www.browserstack.com",
      usernameOptional: !0
    });
    R(this, "authToken");
    const s = (t == null ? void 0 : t.key) ?? process.env.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new u("Missing options.key");
    this.authToken = s;
  }
  /**
   * @internal
   */
  getAccountStatus() {
    return super.getAccountStatus();
  }
  /**
   * Retrieves a list of recent Local binary instances from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of active Local instances.
   */
  getBinaryInstances(t, s) {
    return this.makeGetRequest("/local/v1/list", {
      ...s,
      params: {
        query: {
          ...t,
          auth_token: this.authToken
        }
      }
    }).then((a) => a.instances);
  }
  /**
   * Retrieves details of a Local binary instance from the server.
   *
   * @param localInstanceId The ID of the local binary instance to retrieve.
   * @param query Optional query parameters for the request.
   * @param options Optional fetch options for the request.
   * @returns A promise that resolves to the retrieved local binary instance.
   * @throws {BrowserStackError} If no local binary instance is found with the specified ID.
   */
  getBinaryInstance(t, s, a) {
    return this.makeGetRequest("/local/v1/{localInstanceId}", {
      ...a,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => {
      if (!n.instances.length)
        throw new u(
          `No Local binary instance found with id "${t}"`
        );
      return n.instances[0];
    });
  }
  /**
   * Disconnects a binary instance.
   *
   * @param localInstanceId - The ID of the local binary instance to disconnect.
   * @param query - Optional query parameters for the request.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves to a string representing the message from the server.
   */
  disconnectBinaryInstance(t, s, a) {
    return this.makeDeleteRequest("/local/v1/{localInstanceId}", {
      ...a,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => n.message);
  }
  /**
   * Downloads the BrowserStackLocal binary for the specified operating system architecture and saves it to the specified file path.
   * Note that the file is downloaded to memory for the unzip operation.
   * If the file is large, this method may fail with an out of memory error.
   * This method is intended for use in Node.js environments and will fail in the browser.
   *
   * @param osArch - The operating system architecture for which to download the binary.
   * @param dirPath - The file path where the binary will be saved.
   * @param filenamePrefix - The prefix for the downloaded binary file name inside the ZIP file. Default is "BrowserStackLocal".
   * @param fileMode - The file mode to set for the downloaded binary file. Default is 0o755.
   * @param options - Additional options for the API fetch request.
   * @returns A Promise that resolves when the binary is successfully downloaded and saved.
   */
  async downloadBinary(t, s, a = "BrowserStackLocal", n = 493, m) {
    return this.sdk.GET("/browserstack-local/BrowserStackLocal-{osArch}.zip", {
      ...m,
      params: {
        path: {
          osArch: t
        }
      },
      parseAs: "arrayBuffer"
    }).then((i) => i.response.arrayBuffer()).then(async (i) => {
      const { writeFile: o, unlink: g, stat: c } = await Promise.resolve().then(() => P), { unzipSync: h } = await import("./browser-Ji3eTwqh.js"), { join: f } = await Promise.resolve().then(() => P), l = h(new Uint8Array(i), {
        filter: (w) => w.name.startsWith(a)
      }), k = Object.keys(l);
      if (!k.length)
        throw new u("Local binary not found in zip");
      const d = f(s.toString(), k[0]);
      try {
        return await o(d, l[k[0]], { mode: n }), d;
      } catch (w) {
        try {
          (await c(d)).isFile() && await g(d);
        } catch {
        }
        throw w;
      }
    }).catch((i) => {
      throw i instanceof u ? i : new u(
        `Failed to write local binary to disk: ${i.message}: ${i.stack}`
      );
    });
  }
  /**
   * Runs the downloaded Local binary file with the specified flags and options.
   *
   * @param binFilePath - The path to the executable binary file.
   * @param flags - An array of flags to pass to the executable.
   * @param onData - A callback function to handle stdout data received from the executable.
   * @param onError - A callback function to handle stderr data received from the executable.
   * @param startTimeout - The timeout duration in milliseconds for the executable to start.
   * @param stdoutSuccessMessage - The success message to look for in the stdout of the executable.
   * @returns A promise that resolves with the child process when the executable starts successfully.
   * @throws If an error occurs while executing the binary file.
   */
  async runBinary(t, s = [], a = () => {
  }, n = () => {
  }, m = 1e4, i = "[SUCCESS]") {
    const { execFile: o } = await Promise.resolve().then(() => P), g = o(
      t,
      ["--key", this.authToken, "--enable-logging-for-api", ...s],
      (c, h, f) => {
        if (c)
          throw c;
        a == null || a(h), n == null || n(f);
      }
    );
    return new Promise((c, h) => {
      var l, k;
      const f = setTimeout(h, m);
      n && ((l = g.stderr) == null || l.on("data", n)), (k = g.stdout) == null || k.on("data", (d) => {
        a == null || a(d), d.toUpperCase().includes(i) && (clearTimeout(f), c(g));
      });
    });
  }
}
const ee = {
  AutomateClient: X,
  ScreenshotsClient: Q,
  AppAutomateClient: J,
  JSTestingClient: C,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: C,
  LocalTestingClient: Y,
  BrowserStackError: u
}, P = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null
}, Symbol.toStringTag, { value: "Module" }));
export {
  ee as BrowserStack
};
